
local timePerUpdate=0
local timePerPulsation=timePerUpdate
local timeTot=0
local timePulse=0
local Range=1
local FireAlarm="NO"
local DoorsAreOpen=false
local NumSprinklers=0
local AlarmActive = false
local coveredTiles = {}
local numCovered = -1
local Xmin = 0
local Ymin = 0
local Xmax = 0
local Ymax = 0

local GROUPS = {
		{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate", "SpiritualLeader", "Avatar", "Actor", "Prisoner", "Visitor"},
		{"Sniper", "Workman", "Guard", "RiotGuard", "ArmedGuard", "Doctor", "Paramedic", "Cook", "Gardener", "Janitor", "DogHandler", "Dog", "Teacher", "Soldier", "Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
		{"Prisoner", "Avator", "Actor"},
		{"Sniper", "Guard", "RiotGuard", "ArmedGuard", "Soldier"},
		{"Paramedic", "Fireman", "Soldier", "RiotGuard"},
		{"Warden", "Chief", "Foreman", "Psychologist", "Accountant", "Lawyer", "AppealsLawyer", "ParoleLawyer", "ParoleOfficer", "AppealsMagistrate"},
		{"Visitor"}}

function Create()
	local timePerUpdate=2.5
	Object.SetProperty(this,"AlarmUID",me["id-uniqueId"])
	Object.SetProperty(this,"Range",3)
	Object.SetProperty(this,"FireAlarm","NO")
	Interface.AddComponent(this,"toggleDeleteAlarm", "Button", "tooltip_button_deletealarm")
	Interface.AddComponent(this,this.AlarmUID.."AlarmCaption", "Caption", "tooltip_evacalarmoptions")
	Interface.AddComponent(this,"toggleRangePlus", "Button", "tooltip_button_changerangeplus")
	Interface.AddComponent(this,"toggleShowCoveredEvacArea", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
	Interface.AddComponent(this,"toggleRangeMinus", "Button", "tooltip_button_changerangeminus")
	Interface.AddComponent(this,this.AlarmUID.."AlarmOptions", "Caption", "tooltip_boothconfig")
	Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_off","X")
end

function SpawnAlarmLight()
	if this.Or.x==-1 then -- rotated once
		MyAlarmLight = Object.Spawn("StatusLight", this.Pos.x-0.24000,this.Pos.y)
		Object.SetProperty(MyAlarmLight,"Or.x",1)
		Object.SetProperty(MyAlarmLight,"Or.y",0)
	elseif this.Or.y==-1 then -- rotated twice
		MyAlarmLight = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y-0.20000)
		Object.SetProperty(MyAlarmLight,"Or.x",0)
		Object.SetProperty(MyAlarmLight,"Or.y",1)
	elseif this.Or.x==1 then -- rotated three times
		MyAlarmLight = Object.Spawn("StatusLight", this.Pos.x+0.24000,this.Pos.y)
		Object.SetProperty(MyAlarmLight,"Or.x",-1)
		Object.SetProperty(MyAlarmLight,"Or.y",0)
	else --placed down
		MyAlarmLight = Object.Spawn("StatusLight", this.Pos.x,this.Pos.y-0.10000)
		Object.SetProperty(MyAlarmLight,"Or.x",0)
		Object.SetProperty(MyAlarmLight,"Or.y",-1)
	end
	Object.SetProperty(MyAlarmLight,"AlarmUID",this.AlarmUID)
	MyAlarmLight.Tooltip={"tooltip_AlarmLight",this.AlarmUID,"X"}
end

function toggleDeleteAlarmClicked()
	HideCoveredArea()
	if MyAlarmLight~=nil then MyAlarmLight.Delete() end
	this.Delete()
end

function toggleShowCoveredEvacAreaClicked()
	if CoveredByEvac==true then
		HideCoveredArea()
		CoveredByEvac=false
	else
		ShowCoveredArea()
		CoveredByEvac=true
	end
end

function GetRangeXminYmax(RangeToGet)
	if this.Or.x==-1 then-- rotated once
		Xmin=math.floor(this.Pos.x-RangeToGet)
		Xmax=this.Pos.x
		Ymin=math.ceil(this.Pos.y-RangeToGet/2)
		Ymax=math.floor(this.Pos.y+RangeToGet/2)
	elseif this.Or.y==-1 then -- rotated twice
		Xmin=math.floor(this.Pos.x-RangeToGet/2)
		Xmax=math.ceil(this.Pos.x+RangeToGet/2)
		Ymin=math.ceil(this.Pos.y-RangeToGet)
		Ymax=this.Pos.y
	elseif this.Or.x==1 then -- rotated three times
		Xmin=this.Pos.x
		Xmax=math.ceil(this.Pos.x+RangeToGet)
		Ymin=math.ceil(this.Pos.y-RangeToGet/2)
		Ymax=math.floor(this.Pos.y+RangeToGet/2)
	else --placed down
		Xmin=math.floor(this.Pos.x-RangeToGet/2)
		Xmax=math.ceil(this.Pos.x+RangeToGet/2)
		Ymin=this.Pos.y
		Ymax=math.floor(this.Pos.y+RangeToGet)
	end
end

function HideCoveredArea()
	local CoveredAreaTiles = GetObjectsInSquare("EvacAreaCovered", this.Range)
	if next(CoveredAreaTiles) then
		for thatTile,dist in pairs( CoveredAreaTiles ) do
			if thatTile.AlarmUID==this.AlarmUID and thatTile.CoverType=="Evac" then
				thatTile.Delete()
			end
		end
		CoveredAreaTiles = nil
	end
end

function ShowCoveredArea()
	GetRangeXminYmax(this.Range)
	for i=Ymin,Ymax do
		newCoveredAreaTile = Object.Spawn("EvacAreaCovered",Xmin,i)
		Object.SetProperty(newCoveredAreaTile,"AlarmUID",this.AlarmUID)
		Object.SetProperty(newCoveredAreaTile,"CoverType","Evac")
		if this.EvacType~=nil then Object.SetProperty(newCoveredAreaTile,"SubType",this.EvacType) end
		newCoveredAreaTile.Tooltip={"tooltip_coveredalarm",this.AlarmUID,"X"}
		end
	for i=Xmin,Xmax do
		newCoveredAreaTile = Object.Spawn("EvacAreaCovered",i,Ymin)
		Object.SetProperty(newCoveredAreaTile,"AlarmUID",this.AlarmUID)
		Object.SetProperty(newCoveredAreaTile,"CoverType","Evac")
		if this.EvacType~=nil then Object.SetProperty(newCoveredAreaTile,"SubType",this.EvacType) end
		newCoveredAreaTile.Tooltip={"tooltip_coveredalarm",this.AlarmUID,"X"}
	end
	for i=Ymin,Ymax do
		newCoveredAreaTile = Object.Spawn("EvacAreaCovered",Xmax,i)
		Object.SetProperty(newCoveredAreaTile,"AlarmUID",this.AlarmUID)
		Object.SetProperty(newCoveredAreaTile,"CoverType","Evac")
		if this.EvacType~=nil then Object.SetProperty(newCoveredAreaTile,"SubType",this.EvacType) end
		newCoveredAreaTile.Tooltip={"tooltip_coveredalarm",this.AlarmUID,"X"}
	end
	for i=Xmin,Xmax do
		newCoveredAreaTile = Object.Spawn("EvacAreaCovered",i,Ymax)
		Object.SetProperty(newCoveredAreaTile,"AlarmUID",this.AlarmUID)
		Object.SetProperty(newCoveredAreaTile,"CoverType","Evac")
		if this.EvacType~=nil then Object.SetProperty(newCoveredAreaTile,"SubType",this.EvacType) end
		newCoveredAreaTile.Tooltip={"tooltip_coveredalarm",this.AlarmUID,"X"}
	end
	newCoveredAreaTile=nil
end

function toggleRangePlusClicked()
	if Range<=49 then
		if CoveredByEvac==true then
			HideCoveredArea()
			CoveredByEvac=false
		end
		Range=Range+2
		Object.SetProperty(this,"Range",Range)
		this.SetInterfaceCaption("toggleRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredEvacArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("toggleRangeMinus", "tooltip_button_changerangeminus")
		if this.FireAlarm=="YES" then
			FindMySprinklers()
		end
		ShowCoveredArea()
		CoveredByEvac=true
	end
end

function toggleRangeMinusClicked()
	if Range>=5 then
		if CoveredByEvac==true then
			HideCoveredArea()
			CoveredByEvac=false
		end
		Range=Range-2
		if this.FireAlarm=="YES" then	ResetMySprinklers() end
		Object.SetProperty(this,"Range",Range)
		this.SetInterfaceCaption("toggleRangePlus", "tooltip_button_changerangeplus")
		this.SetInterfaceCaption("toggleShowCoveredEvacArea", "tooltip_button_ShowHideRange",this.Range,"X")
		this.SetInterfaceCaption("toggleRangeMinus", "tooltip_button_changerangeminus")
		if this.FireAlarm=="YES" then
			FindMySprinklers()
		end
		ShowCoveredArea()
		CoveredByEvac=true
	end
end

function toggleFireAlarmClicked()
	if FireAlarm=="YES" then
		FireAlarm="NO"
		this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_alsofirealarm","tooltip_off","X")
	else
		FireAlarm="YES"
		this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_alsofirealarm","tooltip_on","X")
	end
	Object.SetProperty(this,"FireAlarm",FireAlarm)
	if this.FireAlarm=="YES" then
		FindMySprinklers()
		Interface.AddComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
	else
		ResetMySprinklers()
		MySprinklers=nil
		Interface.RemoveComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
	end
end

function toggleFindSprinklersClicked()
	FindMySprinklers()
end

function FindMySwitch()
	this.LastTriggeredBySwitch=""
	this.EvacPosX=""
	this.EvacPosY=""
	local Switches = this.GetNearbyObjects('PowerSwitch',1000)
	for thatSwitch, distance in pairs (Switches) do
		if thatSwitch.Id.i==this.TriggeredBy.i and thatSwitch.Id.u==this.TriggeredBy.u then
			Object.SetProperty(this,"HomeUID", thatSwitch.HomeUID)
			Object.SetProperty(this,"LastTriggeredBySwitch", thatSwitch.Id.u)
			Object.SetProperty(this,"EvacPosX",thatSwitch.Pos.x)
			Object.SetProperty(this,"EvacPosY",thatSwitch.Pos.y+3)
			MySwitch = thatSwitch
			break
		end
	end
	Switches=nil
end

function DeleteOldAlarmLight()
	local nearbyLights = this.GetNearbyObjects('StatusLight',2)
	for thatLight, distance in pairs (nearbyLights) do
		if thatLight.AlarmUID==this.AlarmUID then
			thatLight.Delete()
			break
		end
	end
	nearbyLights=nil
end

function FindMyEvacType()
	FindMySwitch()
	this.EvacType=""
	if this.LastTriggeredBySwitch~=nil then
		local Panels = this.GetNearbyObjects('Pager',1000)
		for thatPanel, distance in pairs (Panels) do
			if thatPanel.HomeUID==this.HomeUID then
				Object.SetProperty(this,"EvacType", thatPanel.EvacType)
				break
			end
		end
		Panels=nil
	end
end

function DoubleCheckMySwitch()
	if MySwitch==nil then FindMySwitch() end
	if this.LastTriggeredBySwitch~=nil then
		if this.TriggeredBy.u~=this.LastTriggeredBySwitch then
			FindMyEvacType()
		end
	else
		FindMyEvacType()
	end
end

function GetObjectsInSquare(theObject,theRange) -- returns targetobjects in a square facing the object
	GetRangeXminYmax(theRange)
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function FindMySprinklers()
	MySprinklers={}
	NumSprinklers=0
	MySprinklers = GetObjectsInSquare('Sprinkler',this.Range)
	for thatSprinkler, distance in pairs (MySprinklers) do
		if thatSprinkler.SubType==0 then
			Object.SetProperty(thatSprinkler,"SubType",1)
		end
		NumSprinklers=NumSprinklers+1
	end
	this.SetInterfaceCaption("toggleFindSprinklers", "tooltip_button_scansprinklers",NumSprinklers,"X")
end

function ResetMySprinklers()
	for thatSprinkler, distance in pairs (MySprinklers) do
		Object.SetProperty(thatSprinkler,"SubType",0)
	end
end

function TriggerDoors(DoorMode,SetMode)
	local doorgroup = {"JailDoor","JailDoorLarge","RemoteDoor","SolitaryDoor","StaffDoor"}
	for _, typ in pairs(doorgroup) do
		local doortype = GetObjectsInSquare(typ,this.Range)
		for thatDoor, _ in pairs(doortype) do
			if thatDoor.Mode~=DoorMode then
				Object.SetProperty(thatDoor,"Mode",SetMode)
			end
		end
		doortype=nil
	end
	doorgroup=nil
end

function DoEvacuate()
	DoubleCheckMySwitch()
	if this.EvacType~=nil then
		if Object.GetProperty(MySwitch,"EvacTestRun")=="NO" then
			local NumPrisoners=0
			local NumPeople=0
			if MyAlarmLight==nil then SpawnAlarmLight() end
			Object.SetProperty(MyAlarmLight,"Triggered",5)
			Object.Sound("EvacAlarm","SoundAlarm")
			local group = GROUPS[this.EvacType]
			for _, typ in pairs(group) do
				local people = GetObjectsInSquare(typ,this.Range) -- this.GetNearbyObjects(typ, this.Range)
				for entity, _ in pairs(people) do
					if entity.Type=="Prisoner" then
						Object.ClearRouting(entity) --clearrouting doesn't seem to kill jobs, so have to do that manually
						entity.JobId=0 -- kill prisoners job
						entity.Station.i=0 -- clear the links to whatever he was working on
						entity.Station.u=0
						entity.StatusEffects.suppressed = 0 -- remove suppression so he can run fast
						entity.Needs.Evacuation = 100 -- give him some reasons to run
						entity.Needs.Safety = 100
						NumPrisoners=NumPrisoners+1
					else
						Object.ClearRouting(entity)
						Object.NavigateTo(entity, this.EvacPosX, this.EvacPosY)
						NumPeople=NumPeople+1
					end
				end
			end
			this.Tooltip={"tooltip_evacuated",this.AlarmUID,"S",this.HomeUID,"W",NumPrisoners,"X",NumPeople,"Y"}
		else
			if MyAlarmLight==nil then SpawnAlarmLight() end
			Object.SetProperty(MyAlarmLight,"Triggered",5)
			Object.Sound("EvacAlarm","SoundAlarm")
			this.Tooltip={"tooltip_alarmtestrun",this.AlarmUID,"S",this.HomeUID,"W"}
		end
	else
		this.Tooltip={"tooltip_EvacuationAlarmSelective",this.AlarmUID,"S"}
	end
end

function DoFireEvac()
	DoubleCheckMySwitch()
	if this.EvacType~=nil then
		local NumPrisoners=0
		local NumPeople=0
		if MyAlarmLight==nil then SpawnAlarmLight() end
		Object.SetProperty(MyAlarmLight,"Triggered",5)
        Object.Sound("_Failure","TimerTickHours")
		local group = GROUPS[1]
		for _, typ in pairs(group) do
			local people = GetObjectsInSquare(typ,this.Range) -- this.GetNearbyObjects(typ, this.Range)
			for entity, _ in pairs(people) do
				if entity.Type=="Prisoner" then
					Object.ClearRouting(entity) --clearrouting doesn't seem to kill jobs, so have to do that manually
					entity.JobId=0 -- kill prisoners job
					entity.Station.i=0 -- clear the links to whatever he was working on
					entity.Station.u=0
					entity.StatusEffects.suppressed = 0 -- remove suppression so he can run fast
					entity.Needs.Evacuation = 100 -- give him some reasons to run
					entity.Needs.Safety = 100
					NumPrisoners=NumPrisoners+1
				else
					Object.ClearRouting(entity)
					Object.NavigateTo(entity, this.EvacPosX, this.EvacPosY)
					NumPeople=NumPeople+1
				end
			end
		end
		this.Tooltip={"tooltip_fireevacuated",this.AlarmUID,"S",this.HomeUID,"W",NumPrisoners,"X",NumPeople,"Y"}
	else
		this.Tooltip={"tooltip_EvacuationAlarmSelective",this.AlarmUID,"S"}
	end
end

function CheckForFire()
	for thatSprinkler, distance in pairs (MySprinklers) do
		if thatSprinkler.Active~=nil then
			if thatSprinkler.Active~=false then
				AlarmActive=true
				DoFireEvac()
			end
		end
	end
end

function Update( timePassed )
	if timePerUpdate==0 then
		if this.AlarmUID==nil then
			Object.SetProperty(this,"AlarmUID",me["id-uniqueId"])
		end
		DeleteOldAlarmLight()
		Range=this.Range
		FireAlarm = this.FireAlarm
		Interface.AddComponent(this,"toggleDeleteAlarm", "Button", "tooltip_button_deletealarm")
		Interface.AddComponent(this,this.AlarmUID.."AlarmCaption", "Caption", "tooltip_evacalarmoptions")
		Interface.AddComponent(this,"toggleRangePlus", "Button", "tooltip_button_changerangeplus")
		Interface.AddComponent(this,"toggleShowCoveredEvacArea", "Button", "tooltip_button_ShowHideRange",this.Range,"X")
		Interface.AddComponent(this,"toggleRangeMinus", "Button", "tooltip_button_changerangeminus")
		Interface.AddComponent(this,this.AlarmUID.."AlarmOptions", "Caption", "tooltip_boothconfig")
		if FireAlarm=="NO" then
			Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_off","X")
		elseif FireAlarm=="YES" then 
			Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_alsofirealarm","tooltip_on","X")
			Interface.AddComponent(this,"toggleFindSprinklers", "Button", "tooltip_button_scansprinklers",NumSprinklers,"X")
			FindMySprinklers()
		end
		if this.EvacType~=nil then
			this.Tooltip={"tooltip_usedbybooth",this.AlarmUID,"S",this.HomeUID,"Y"} -- initialize tooltip again after loading saved game, otherwise it will show *X instead of the homeUID in the tooltip...
		else
			this.Tooltip={"tooltip_EvacuationAlarmSelective",this.AlarmUID,"S"}
		end
		timePerUpdate=math.random(5,10)
		timePerPulsation=timePerUpdate
	end
	
	timeTot = timeTot + timePassed
	timePulse = timePulse + timePassed
	
	if timeTot>=timePerUpdate then
		timeTot=0
		
		if this.EvacType~=nil then
			this.Tooltip={"tooltip_usedbybooth",this.AlarmUID,"S",this.HomeUID,"Y"}
		else
			this.Tooltip={"tooltip_EvacuationAlarmSelective",this.AlarmUID,"S"}
			FindMyEvacType() -- find the panel which belongs to it so we know which type of people should respond and the location where they should be send.
		end
		
		AlarmActive=false
		if this.FireAlarm=="YES" then
			CheckForFire()
		end
		
		local hasPower = ( this.Triggered or 0 ) > 0
		if hasPower then
			AlarmActive=true
			DoEvacuate()
		end

		if AlarmActive==true and DoorsAreOpen==false then TriggerDoors('LockedOpen',2); DoorsAreOpen=true;	timePerPulsation=2 end
		if AlarmActive==false and DoorsAreOpen==true then TriggerDoors('Normal',0); 	DoorsAreOpen=false;	timePerPulsation=timePerUpdate; MyAlarmLight.Delete(); MyAlarmLight=nil end
	end
	
	if timePulse>=timePerPulsation and AlarmActive==true then
		timePulse=0
		Object.SetProperty(MyAlarmLight,"Triggered",5)
	end
	
end
