
-- This UtilityPanel gets spawned by the panels from the menu (which on their turn get deleted)
-- Why is there no pager panel script? Because the pagers just hold a value which gets imported via the utilitybooth into the utilitypanel

local timeTot=0
local myStaff={}
local PanelSprites = { Workman = 0, Guard = 1, Dog  = 2, SnitchSorter = 6, Doctor = 10, Gardener = 11, Janitor = 12, Cook = 13 }

function Create()
	local timePerUpdate=math.random(720,1440)
	Interface.AddComponent(this,"toggleDeletePanel", "Button", "tooltip_button_deletepanel")
end

function toggleDeletePanelClicked()
	this.Delete()
end

function Update( timePassed )
	if timePerUpdate==nil then
		Interface.AddComponent(this,"toggleDeletePanel", "Button", "tooltip_button_deletepanel")
		timePerUpdate=math.random(720,1440)
	end
	timeTot = timeTot + timePassed
	if timeTot>=timePerUpdate then
		timeTot=0
	end
end

function TurnMySwitchOff()
	--check for my switch and turn it off. Dog panels use this, so combined with a workman or guard panel in a medium/large booth, this will also dismiss any guards or workmen who are spawned when the dogs are released.
	-- so dog panels should not be combined with other panels in a booth (duh).
	local mySwitch = this.GetNearbyObjects('PowerSwitch',2)
	for thatSwitch, distance in pairs (mySwitch) do
		if thatSwitch.HomeUID==this.HomeUID then
			Object.SetProperty(thatSwitch,"Switch",false)
			this.SubType = 2; -- show the 'Dog' display
			break;
		end
	end
end

function JobComplete_ReleaseDogs()
	Object.SetProperty(this,"CallCompleted","true")
	Object.Sound( "UtilityBooth", "CallCompleted" )
	for j=1,this.xTimes,1 do
		newDog = Object.Spawn(this.PanelType,this.Pos.x,this.Pos.y+1)
		Object.SetProperty(newDog,"Tooltip","tooltip_hungrydog")
	end
	Object.SetProperty(this,"SubType",PanelSprites[this.PanelType])
	TurnMySwitchOff()
	--Game.DebugOut("Staff Summoned")
end

function JobComplete_CallStaff()
	Object.SetProperty(this,"CallCompleted","true")
	Object.Sound( "UtilityBooth", "CallCompleted" )
	myStaff={}
	for j=1,this.xTimes,1 do
			myStaff[j] = Object.Spawn(this.PanelType,this.Pos.x,this.Pos.y+1)
		if this.PanelType=="Guard" then
			Object.SetProperty(myStaff[j],"SubType",math.random(0,3)+4)
			Object.SetProperty(myStaff[j],"SecondaryEquipment",37) -- give guards a tazer
		end
		if this.PanelType=="Workman" then
			Object.SetProperty(myStaff[j],"SubType",math.random(0,3)+4)
		end
		Object.SetProperty(myStaff[j],"HomeUID",this.HomeUID)
		Object.SetProperty(myStaff[j],"Tooltip","Temporary Staff\nCalled by Utility booth "..this.HomeUID)
	end
	Object.SetProperty(this,"SubType",PanelSprites[this.PanelType])
	--Game.DebugOut("Staff Summoned")
end

function JobComplete_DeleteStaff()
	Object.SetProperty(this,"CallCompleted","false")
	Object.Sound( "UtilityBooth", "DeleteStaff" )
	if next(myStaff) then
		for j=1,this.xTimes,1 do
			myStaff[j].Delete()
		end
		myStaff=nil
	else
		local staff = this.GetNearbyObjects( this.PanelType, 500 )
		for name,distance in pairs( staff ) do
			if name.HomeUID==this.HomeUID then
				name.Delete()
			end
		end
		staff=nil
	end
	Object.SetProperty(this,"SubType",PanelSprites[this.PanelType])
	--Game.DebugOut("Staff Summoned")
end
